diff --git a/src/src/moan.c b/src/src/moan.c
index 5635f93e2..01bf4f578 100644
--- a/src/src/moan.c
+++ b/src/src/moan.c
@@ -167,7 +167,7 @@ int written = 0, fd, status, count = 0, size_limit = bounce_return_size_limit;
 FILE * fp;
 int pid;
 
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
 uschar * s, * s2;
 
 /* For DMARC if there is a specific sender set, expand the variable for the
@@ -206,7 +206,7 @@ fp = fdopen(fd, "wb");
 if (errors_reply_to) fprintf(fp, "Reply-To: %s\n", errors_reply_to);
 fprintf(fp, "Auto-Submitted: auto-replied\n");
 
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
 if (s)
   fprintf(fp, "From: %s\n", s);
 else
@@ -324,23 +324,16 @@ switch(ident)
   fprintf(fp, "\n");
   break;
 
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
   case ERRMESS_DMARC_FORENSIC:
     bounce_return_message = TRUE;
     bounce_return_body    = FALSE;
-    fprintf(fp, "Subject: DMARC Forensic Report for %s from IP %s\n\n",
-	  eblock ? eblock->text2 : US"Unknown",
-          sender_host_address);
-    fprintf(fp,
-      "A message claiming to be from you has failed the published DMARC\n"
-      "policy for your domain.\n\n");
-    while (eblock)
-      {
-      fprintf(fp, "  %s: %s\n", eblock->text1, eblock->text2);
-      count++;
-      eblock = eblock->next;
-      }
-  break;
+    for (; eblock; eblock = eblock->next)
+      if (eblock->text2)
+	fprintf(fp, "  %s: %s\n", eblock->text1, eblock->text2);
+      else
+	fprintf(fp, "%s", eblock->text1);
+    break;
 #endif
 
   default:
@@ -435,13 +428,13 @@ if (bounce_return_message)
       fputs(CS buf, fp);
       }
     }
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
   /* Overkill, but use exact test in case future code gets inserted */
-  else if (bounce_return_body && message_file == NULL)
+  else if (bounce_return_body && !message_file)
     {
     /*XXX limit line length here? */
     /* This doesn't print newlines, disable until can parse and fix
-     * output to be legible.  */
+    output to be legible.  */
     fprintf(fp, "%s", expand_string(US"$message_body"));
     }
 #endif
diff --git a/src/src/readconf.c b/src/src/readconf.c
index 1fe2b2bfc..04cd5e68a 100644
--- a/src/src/readconf.c
+++ b/src/src/readconf.c
@@ -124,7 +124,7 @@ static optionlist optionlist_config[] = {
   { "dkim_verify_minimal",      opt_module,	 {US"dkim"} },
   { "dkim_verify_signers",      opt_module,	 {US"dkim"} },
 #endif
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
   { "dmarc_forensic_sender",    opt_module,	 {US"dmarc"} },
   { "dmarc_history_file",       opt_module,	 {US"dmarc"} },
   { "dmarc_tld_file",           opt_module,	 {US"dmarc"} },
diff --git a/src/src/receive.c b/src/src/receive.c
index cde09c40a..0f407ce93 100644
--- a/src/src/receive.c
+++ b/src/src/receive.c
@@ -16,7 +16,7 @@
 extern int dcc_ok;
 #endif
 
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
 # include "miscmods/dmarc.h"
 #endif
 
@@ -1754,9 +1754,6 @@ BOOL date_header_exists = FALSE;
 /* Pointers to receive the addresses of headers whose contents we need. */
 
 header_line * from_header = NULL;
-#ifdef SUPPORT_DMARC
-header_line * dmarc_from_header = NULL;
-#endif
 header_line * subject_header = NULL, * msgid_header = NULL, * received_header;
 BOOL msgid_header_newly_created = FALSE;
 
@@ -2454,8 +2451,16 @@ for (header_line * h = header_list->next; h; h = h->next)
 
     case htype_from:
       h->type = htype_from;
-#ifdef SUPPORT_DMARC
-      if (!is_resent) dmarc_from_header = h;
+#ifdef EXIM_HAVE_DMARC
+      if (!is_resent && !f.dmarc_disable_verify)
+	{
+	misc_module_info * mi = misc_mod_findonly(US"dmarc");
+	if (mi)
+	  {
+	  typedef void (*fn_t)(const uschar *);
+	  (((fn_t *) mi->functions)[DMARC_STORE_FROMHDR]) (h->text);
+	  }
+	}
 #endif
       if (!resents_exist || is_resent)
 	{
@@ -3584,17 +3589,6 @@ else
       }
 #endif /* WITH_CONTENT_SCAN */
 
-#ifdef SUPPORT_DMARC
-    {
-    misc_module_info * mi = misc_mod_findonly(US"dmarc");
-    if (mi)
-      {
-      typedef int (*fn_t)(header_line *);
-      (((fn_t *) mi->functions)[DMARC_STORE_DATA]) (dmarc_from_header);
-      }
-    }
-#endif
-
 #ifndef DISABLE_PRDR
     if (prdr_requested && recipients_count > 1)
       {
diff --git a/src/src/regex_cache.c b/src/src/regex_cache.c
index b92556d92..713da90d5 100644
--- a/src/src/regex_cache.c
+++ b/src/src/regex_cache.c
@@ -142,7 +142,7 @@ size_t offset;
 const pcre2_code * yield;
 int old_pool = store_pool, err;
 
-/* Optionall, check the cache and return if found */
+/* Optionally, check the cache and return if found */
 
 if (  flags & MCS_CACHEABLE
    && (yield = regex_from_cache(pattern, caseless)))

